func int getAscii(string $string)
{
  string $ascii[75] = string[75]{"0","1","2","3","4","5","6","7","8","9",":",";","<","=",">","?","@","A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z","["," ","]","^","_","'","a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z"}
  int $code = 0

  for $code < 75 do ++$code
  {
    if($ascii[$code] == $string)
    {
      return $code + 16
    }
  }  
} 


func void moveModel(rcarmodel $model, float $posx, float $posy, float $posz)
{
  set $model position float[3]{$posx,$posy,$posz}
}


func void rotateModel(rcarmodel $model, float $ax, float $ay, float $az)
{
  set $model rotation float[3]{$ax,$ay,$az}
}


//$currpercent	0.0 to 1.0	percentage to end position (0.0 is at start, 1.0 is at end)
//$time		0.0+		time in ms that the animation takes to complete
//$direction	0 or 1		0: going toward start position, 1: going toward end position
func float moveAndRotate(rcarmodel $model, float $currpercent, float $time, int $direction, float $startx, float $starty, float $startz, float $endx, float $endy, float $endz, float $offsetx, float $offsety, float $offsetz, float $startax, float $startay, float $startaz, float $endax, float $enday, float $endaz)
{
  float $percent

  if($time < 0)
  {
    $time = 0
  }

  if($direction == 1)
  { 
    $percent = (($currpercent * $time) + interval) / $time
  }
  else
  {
    $percent = (($currpercent * $time) - interval) / $time
  }

  if($percent > 1)
  {
    $percent = 1
  }

  if($percent < 0)
  {
     $percent = 0
  }

  rotateModel($model, ($endax-$startax) * $percent, ($enday-$startay) * $percent, ($endaz-$startaz) * $percent)

  moveModel($model, (($endx-$startx) * $percent) + $offsetx, (($endy-$starty) * $percent) + $offsety, (($endz-$startz) * $percent) + $offsetz)

  return $percent
}